package org.gcube.portlets.user.geoportaldataviewer.client.ui;

import org.gcube.portlets.user.geoportaldataviewer.client.gis.OsmExample;

import com.github.gwtbootstrap.client.ui.Button;
import com.github.gwtbootstrap.client.ui.Tab;
import com.google.gwt.core.client.GWT;
import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.uibinder.client.UiBinder;
import com.google.gwt.uibinder.client.UiField;
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.HTMLPanel;
import com.google.gwt.user.client.ui.Widget;

public class GeonaDataViewMainPanel extends Composite {

	private static GeonaDataViewMainPanelUiBinder uiBinder = GWT.create(GeonaDataViewMainPanelUiBinder.class);

	interface GeonaDataViewMainPanelUiBinder extends UiBinder<Widget, GeonaDataViewMainPanel> {
	}

	@UiField
	Tab mapPanel;
	
	@UiField
	Button dataPointSelection;
	
	@UiField
	Button dataBoxSelection;
	

	private HTMLPanel htmlPanel;

	private OsmExample map;
	
	public GeonaDataViewMainPanel() {
		initWidget(uiBinder.createAndBindUi(this));
		htmlPanel = new HTMLPanel("");
		htmlPanel.getElement().setId("map");
		htmlPanel.setHeight("600px");
		mapPanel.add(htmlPanel);
		
		dataPointSelection.setToggle(true);
		dataBoxSelection.setToggle(true);
		
		bindHandlers();
	}
	
	public void setHeight(int height) {
		htmlPanel.setHeight(height +"px");
	}

	public HTMLPanel getMapPanel() {
		return htmlPanel;
	}
	
	public void setMap(OsmExample map) {
		this.map = map;
	}
	
	public void bindHandlers(){
		dataPointSelection.addClickHandler(new ClickHandler() {
			
			@Override
			public void onClick(ClickEvent event) {
				map.removeInteractions();
				map.addPointVectorSource();
			}
		});
		
		dataBoxSelection.addClickHandler(new ClickHandler() {
			
			@Override
			public void onClick(ClickEvent event) {
				map.removeInteractions();
				map.addExtentInteraction();
				
			}
		});
		
	}

}
